<template>
  <i-wrapper top>
    <div class="container d-flex flex-column align-items-center">
      <div class="p-title">{{ $t(`Compatibility`) }}</div>
      <div class="p-your-signs">
        <div class="p-your-sign">
          <img
            v-if="yourSign"
            :src="
              require(`~/assets/images/zodiac-${yourSign}-orange${
                zodiacVariants[yourSign] ? `-variant-${zodiacVariants[yourSign]}` : ''
              }.png`)
            "
            class="p-your-sign__image" />
          <span v-else class="p-your-sign__placeholder">{{ $t(`Your sign`) }}</span>
        </div>
        <img src="~assets/images/compatibility-plus-white.svg" class="p-your-sign-plus-image" />
        <div class="p-your-sign">
          <img
            v-if="partnerSign"
            :src="
              require(`~/assets/images/zodiac-${partnerSign}-orange${
                zodiacVariants[partnerSign] ? `-variant-${zodiacVariants[partnerSign]}` : ''
              }.png`)
            "
            class="p-your-sign__image" />
          <span v-else class="p-your-sign__placeholder">{{ $t(`Partner's sign`) }}</span>
        </div>
      </div>
      <div class="p-signs">
        <nuxt-link
          v-for="signCode in signCodes"
          :key="signCode"
          tag="button"
          :event="yourSign && auth.user.hasActiveSubscription ? 'click' : ''"
          class="p-sign"
          :class="{ 'p-sign--selected': signCode === yourSign || signCode === partnerSign }"
          :to="{
            name: 'compatibility.combination',
            params: { combination: `${yourSign}-${signCode}` },
          }"
          @click.native="selectSign(signCode)">
          <img
            :src="
              require(`~/assets/images/zodiac-${signCode}-orange${
                zodiacVariants[signCode] ? `-variant-${zodiacVariants[signCode]}` : ''
              }.png`)
            "
            class="p-sign__image" />
          <span class="p-sign__title">{{ $t(`signNames.${signCode}`) }}</span>
        </nuxt-link>
      </div>
    </div>
    <i-unlock-full-access ref="iUnlockFullAccess" @hide="clearSigns()" />
    <template #bottom>
      <i-bottom-panel />
    </template>
  </i-wrapper>
</template>

<script>
  import { mapState } from 'vuex';

  export default {
    layout: 'default',
    nuxtI18n: false,
    middleware: ['logged-in-only'],

    data() {
      return {
        yourSign: null,
        partnerSign: null,

        zodiacVariants: {
          aquarius: 2,
          cancer: 2,
        },

        signCodes: [
          'libra',
          'leo',
          'aries',
          'pisces',
          'taurus',
          'aquarius',
          'virgo',
          'scorpio',
          'capricorn',
          'cancer',
          'sagittarius',
          'gemini',
        ],
      };
    },

    computed: {
      ...mapState(['auth']),
    },

    methods: {
      async selectSign(signCode) {
        if (!this.auth.user.hasActiveSubscription) {
          this.$refs.iUnlockFullAccess.show();
          return;
        }

        if (!this.yourSign) {
          this.yourSign = signCode;
          return;
        }

        this.partnerSign = signCode;
      },

      clearSigns() {
        this.yourSign = null;
        this.partnerSign = null;
      },
    },
  };
</script>

<style lang="scss" scoped>
  .p-title {
    color: #fff;
    font-size: rf(30px);
    font-weight: bold;
    text-align: center;
    margin-top: rs(5px);
  }

  .p-your-signs {
    display: flex;
    align-items: center;
    margin-top: rs(25px);
  }

  .p-your-sign-plus-image {
    width: rs(36px);
    height: rs(36px);
    margin-left: rs(5px);
    margin-right: rs(5px);
  }

  .p-your-sign {
    display: flex;
    align-items: center;
    justify-content: center;
    width: rs(100px);
    height: rs(100px);
  }

  .p-your-sign__placeholder {
    display: flex;
    align-items: center;
    text-align: center;
    justify-content: center;
    width: rs(85px);
    height: rs(85px);
    box-sizing: border-box;
    background-color: #f78472;
    border: rs(3px) solid #961937;
    border-radius: rs(math.div(85px, 2));
    color: #fff;
    font-size: rf(14px);
    font-weight: bold;
    line-height: 140%;
  }

  .p-your-sign__image {
    width: rs(100px);
    height: rs(100px);
  }

  .p-signs {
    display: flex;
    flex-wrap: wrap;
    padding: 0 rs(20px);
    margin-top: rs(20px);
  }

  .p-sign {
    position: relative;
    display: flex;
    flex-direction: column;
    align-items: center;
    flex-grow: 1;
    flex-basis: 33.3333%;
    width: rs(88px);
    margin-bottom: rs(5px);
    background-color: transparent;
    border: 0;
    cursor: pointer;

    &::before {
      display: block;
      content: '';
      position: absolute;
      z-index: 0;
      top: rs(6px);
      left: 50%;
      transform: translateX(-50%);
      width: rs(69px);
      height: rs(69px);
      background-color: #fff;
      border-radius: rs(math.div(69px, 2));
    }
  }

  .p-sign:not(.p-sign--selected) {
    &::before {
      visibility: hidden;
    }
  }

  .p-sign__image {
    position: relative;
    z-index: 1;
    width: rs(80px);
    height: rs(80px);
    border: rs(4px) solid transparent;
  }

  .p-sign__title {
    color: #fff;
    font-size: rf(14px);
    font-weight: bold;
    margin-top: rs(-5px);
  }
</style>
